module HCSR04_RCWL1601(
	clk,
	rst_n,
	echo,
	trig,
	data);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input echo;
	output trig;
	output [15:0] data;

	wire clk;
	wire rst_n;
	wire echo;
	reg trig;
	reg [15:0] data;

	//----Code starts here: integrated by Robei-----
	//parameter  P_500MS = 8333333;//for board
	parameter  P_500MS = 8333;//for test
	
	reg [2:0] echo_delay;
	
	//յechoźŴģ½
	always@(posedge clk, negedge rst_n)begin
			if(!rst_n)
					echo_delay <= 1'd0;
			else 
					echo_delay <= {echo_delay[1:0], echo};
	end 
	
	//½
	wire nege_echo;
	wire pose_echo;
	assign pose_echo = (~echo_delay[2])&&echo_delay[1];
	assign nege_echo = echo_delay[2]&&(!echo_delay[1]);
	
	//ʹźţechoߵƽڼ俪ʼecho͵ƽڼֹͣ
	reg cnt_17K_en;
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					cnt_17K_en <= 1'd0;
			else if(pose_echo)
					cnt_17K_en <= 1'b1;
			else if(nege_echo)
					cnt_17K_en <= 1'b0;
			else 
					cnt_17K_en <= cnt_17K_en;
	end
	
	//17KHzһԼ59us
	reg [10:0] cnt_17K;
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					cnt_17K <= 1'd0;
			else if(cnt_17K_en)begin
					if(cnt_17K == 11'd1961)
							cnt_17K <= 1'd0;
					else 
							cnt_17K <= cnt_17K + 1'b1;
			end
			else 
					cnt_17K <= 1'd0;
	end 
	
	
	reg clk_17K;
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					clk_17K <= 1'b0;
			else if(cnt_17K == 11'd1961)
					clk_17K <= 1'b1;
			else 
					clk_17K <= 1'b0;
	end
	
	//500ms
	reg [22:0] cnt_500Ms;
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					cnt_500Ms <= 1'b0;
			else if(cnt_500Ms == P_500MS) //500msԼĿϵľƵʵ
					cnt_500Ms <= 1'd0;
			else 
					cnt_500Ms <= cnt_500Ms + 1'b1;
	end
	
	//10usߵƽ
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					trig <= 1'b0;
			else if(cnt_500Ms <= 23'd333) 
					trig <= 1'b1; //trigźڴģ鿪ʼ
			else 
					trig <= 1'b0;
	end 
	
	//ʹüм17KHz
	reg [15:0] data_r;
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					data_r <= 1'd0;
			else if(clk_17K == 1'b1)begin
					if(data_r[3 :0 ] == 4'd9)begin
							data_r[7 :4 ] <= 1'b1 + data_r[7 :4 ];
							data_r[3 :0 ] <= 1'd0;
					end 
					else if(data_r[7 :4 ] == 4'd9)begin
							data_r[11:8 ] <= 1'b1 + data_r[11:8 ];
							data_r[7 :4 ] <= 1'd0;
					end 
					else if(data_r[11:8 ] == 4'd9)begin
							data_r[15:12] <= 1'b1 + data_r[15:12];
							data_r[11:8 ] <= 1'd0;
					end 
					else 
							data_r <= data_r + 1'b1;
			end 
			else begin
					if(cnt_500Ms == P_500MS)
							data_r <= 1'd0;
					else
							data_r <= data_r;
			end
	end 
	
	
	//data
	always @ (posedge clk, negedge rst_n)begin
			if(!rst_n)
					data <= 1'd0;
			else if(cnt_500Ms == P_500MS)
					data <= data_r;
			else 
					data <= data;
	end 
	
	
	
	
endmodule    //HCSR04_RCWL1601

